/[gentoo-x86]/eclass/toolchain-funcs.eclass
Gentoo

Diff of /eclass/toolchain-funcs.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.89 Revision 1.118
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/toolchain-funcs.eclass,v 1.89 2009/04/04 17:17:56 grobian Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/toolchain-funcs.eclass,v 1.118 2012/09/27 19:34:28 axs Exp $
4 4
5# @ECLASS: toolchain-funcs.eclass 5# @ECLASS: toolchain-funcs.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Toolchain Ninjas <toolchain@gentoo.org> 7# Toolchain Ninjas <toolchain@gentoo.org>
8# @BLURB: functions to query common info about the toolchain 8# @BLURB: functions to query common info about the toolchain
11# for gleaning useful information about the toolchain and to simplify 11# for gleaning useful information about the toolchain and to simplify
12# ugly things like cross-compiling and multilib. All of this is done 12# ugly things like cross-compiling and multilib. All of this is done
13# in such a way that you can rely on the function always returning 13# in such a way that you can rely on the function always returning
14# something sane. 14# something sane.
15 15
16___ECLASS_RECUR_TOOLCHAIN_FUNCS="yes" 16if [[ ${___ECLASS_ONCE_TOOLCHAIN_FUNCS} != "recur -_+^+_- spank" ]] ; then
17[[ -z ${___ECLASS_RECUR_MULTILIB} ]] && inherit multilib 17___ECLASS_ONCE_TOOLCHAIN_FUNCS="recur -_+^+_- spank"
18 18
19DESCRIPTION="Based on the ${ECLASS} eclass" 19inherit multilib
20 20
21# tc-getPROG <VAR [search vars]> <default> [tuple]
21tc-getPROG() { 22_tc-getPROG() {
22 local var=$1 23 local tuple=$1
24 local v var vars=$2
23 local prog=$2 25 local prog=$3
24 26
25 if [[ -n ${!var} ]] ; then 27 var=${vars%% *}
26 echo "${!var}" 28 for v in ${vars} ; do
27 return 0
28 fi
29
30 local search=
31 [[ -n $3 ]] && search=$(type -p "$3-${prog}")
32 [[ -z ${search} && -n ${CHOST} ]] && search=$(type -p "${CHOST}-${prog}")
33 [[ -n ${search} ]] && prog=${search##*/}
34
35 export ${var}=${prog}
36 echo "${!var}"
37}
38
39# @FUNCTION: tc-getAR
40# @USAGE: [toolchain prefix]
41# @RETURN: name of the archiver
42tc-getAR() { tc-getPROG AR ar "$@"; }
43# @FUNCTION: tc-getAS
44# @USAGE: [toolchain prefix]
45# @RETURN: name of the assembler
46tc-getAS() { tc-getPROG AS as "$@"; }
47# @FUNCTION: tc-getCC
48# @USAGE: [toolchain prefix]
49# @RETURN: name of the C compiler
50tc-getCC() { tc-getPROG CC gcc "$@"; }
51# @FUNCTION: tc-getCPP
52# @USAGE: [toolchain prefix]
53# @RETURN: name of the C preprocessor
54tc-getCPP() { tc-getPROG CPP cpp "$@"; }
55# @FUNCTION: tc-getCXX
56# @USAGE: [toolchain prefix]
57# @RETURN: name of the C++ compiler
58tc-getCXX() { tc-getPROG CXX g++ "$@"; }
59# @FUNCTION: tc-getLD
60# @USAGE: [toolchain prefix]
61# @RETURN: name of the linker
62tc-getLD() { tc-getPROG LD ld "$@"; }
63# @FUNCTION: tc-getSTRIP
64# @USAGE: [toolchain prefix]
65# @RETURN: name of the strip program
66tc-getSTRIP() { tc-getPROG STRIP strip "$@"; }
67# @FUNCTION: tc-getNM
68# @USAGE: [toolchain prefix]
69# @RETURN: name of the symbol/object thingy
70tc-getNM() { tc-getPROG NM nm "$@"; }
71# @FUNCTION: tc-getRANLIB
72# @USAGE: [toolchain prefix]
73# @RETURN: name of the archiver indexer
74tc-getRANLIB() { tc-getPROG RANLIB ranlib "$@"; }
75# @FUNCTION: tc-getOBJCOPY
76# @USAGE: [toolchain prefix]
77# @RETURN: name of the object copier
78tc-getOBJCOPY() { tc-getPROG OBJCOPY objcopy "$@"; }
79# @FUNCTION: tc-getF77
80# @USAGE: [toolchain prefix]
81# @RETURN: name of the Fortran 77 compiler
82tc-getF77() { tc-getPROG F77 f77 "$@"; }
83# @FUNCTION: tc-getFC
84# @USAGE: [toolchain prefix]
85# @RETURN: name of the Fortran 90 compiler
86tc-getFC() { tc-getPROG FC gfortran "$@"; }
87# @FUNCTION: tc-getGCJ
88# @USAGE: [toolchain prefix]
89# @RETURN: name of the java compiler
90tc-getGCJ() { tc-getPROG GCJ gcj "$@"; }
91
92# @FUNCTION: tc-getBUILD_CC
93# @USAGE: [toolchain prefix]
94# @RETURN: name of the C compiler for building binaries to run on the build machine
95tc-getBUILD_CC() {
96 local v
97 for v in CC_FOR_BUILD BUILD_CC HOSTCC ; do
98 if [[ -n ${!v} ]] ; then 29 if [[ -n ${!v} ]] ; then
99 export BUILD_CC=${!v} 30 export ${var}="${!v}"
100 echo "${!v}" 31 echo "${!v}"
101 return 0 32 return 0
102 fi 33 fi
103 done 34 done
104 35
105 local search= 36 local search=
106 if [[ -n ${CBUILD} ]] ; then 37 [[ -n $4 ]] && search=$(type -p "$4-${prog}")
107 search=$(type -p ${CBUILD}-gcc) 38 [[ -z ${search} && -n ${!tuple} ]] && search=$(type -p "${!tuple}-${prog}")
108 search=${search##*/} 39 [[ -n ${search} ]] && prog=${search##*/}
109 fi
110 search=${search:-gcc}
111 40
112 export BUILD_CC=${search} 41 export ${var}=${prog}
113 echo "${search}" 42 echo "${!var}"
114} 43}
44tc-getBUILD_PROG() { _tc-getPROG CBUILD "BUILD_$1 $1_FOR_BUILD HOST$1" "${@:2}"; }
45tc-getPROG() { _tc-getPROG CHOST "$@"; }
46
47# @FUNCTION: tc-getAR
48# @USAGE: [toolchain prefix]
49# @RETURN: name of the archiver
50tc-getAR() { tc-getPROG AR ar "$@"; }
51# @FUNCTION: tc-getAS
52# @USAGE: [toolchain prefix]
53# @RETURN: name of the assembler
54tc-getAS() { tc-getPROG AS as "$@"; }
55# @FUNCTION: tc-getCC
56# @USAGE: [toolchain prefix]
57# @RETURN: name of the C compiler
58tc-getCC() { tc-getPROG CC gcc "$@"; }
59# @FUNCTION: tc-getCPP
60# @USAGE: [toolchain prefix]
61# @RETURN: name of the C preprocessor
62tc-getCPP() { tc-getPROG CPP cpp "$@"; }
63# @FUNCTION: tc-getCXX
64# @USAGE: [toolchain prefix]
65# @RETURN: name of the C++ compiler
66tc-getCXX() { tc-getPROG CXX g++ "$@"; }
67# @FUNCTION: tc-getLD
68# @USAGE: [toolchain prefix]
69# @RETURN: name of the linker
70tc-getLD() { tc-getPROG LD ld "$@"; }
71# @FUNCTION: tc-getSTRIP
72# @USAGE: [toolchain prefix]
73# @RETURN: name of the strip program
74tc-getSTRIP() { tc-getPROG STRIP strip "$@"; }
75# @FUNCTION: tc-getNM
76# @USAGE: [toolchain prefix]
77# @RETURN: name of the symbol/object thingy
78tc-getNM() { tc-getPROG NM nm "$@"; }
79# @FUNCTION: tc-getRANLIB
80# @USAGE: [toolchain prefix]
81# @RETURN: name of the archiver indexer
82tc-getRANLIB() { tc-getPROG RANLIB ranlib "$@"; }
83# @FUNCTION: tc-getOBJCOPY
84# @USAGE: [toolchain prefix]
85# @RETURN: name of the object copier
86tc-getOBJCOPY() { tc-getPROG OBJCOPY objcopy "$@"; }
87# @FUNCTION: tc-getF77
88# @USAGE: [toolchain prefix]
89# @RETURN: name of the Fortran 77 compiler
90tc-getF77() { tc-getPROG F77 gfortran "$@"; }
91# @FUNCTION: tc-getFC
92# @USAGE: [toolchain prefix]
93# @RETURN: name of the Fortran 90 compiler
94tc-getFC() { tc-getPROG FC gfortran "$@"; }
95# @FUNCTION: tc-getGCJ
96# @USAGE: [toolchain prefix]
97# @RETURN: name of the java compiler
98tc-getGCJ() { tc-getPROG GCJ gcj "$@"; }
99# @FUNCTION: tc-getPKG_CONFIG
100# @USAGE: [toolchain prefix]
101# @RETURN: name of the pkg-config tool
102tc-getPKG_CONFIG() { tc-getPROG PKG_CONFIG pkg-config "$@"; }
103# @FUNCTION: tc-getRC
104# @USAGE: [toolchain prefix]
105# @RETURN: name of the Windows resource compiler
106tc-getRC() { tc-getPROG RC windres "$@"; }
107# @FUNCTION: tc-getDLLWRAP
108# @USAGE: [toolchain prefix]
109# @RETURN: name of the Windows dllwrap utility
110tc-getDLLWRAP() { tc-getPROG DLLWRAP dllwrap "$@"; }
111
112# @FUNCTION: tc-getBUILD_AR
113# @USAGE: [toolchain prefix]
114# @RETURN: name of the archiver for building binaries to run on the build machine
115tc-getBUILD_AR() { tc-getBUILD_PROG AR ar "$@"; }
116# @FUNCTION: tc-getBUILD_AS
117# @USAGE: [toolchain prefix]
118# @RETURN: name of the assembler for building binaries to run on the build machine
119tc-getBUILD_AS() { tc-getBUILD_PROG AS as "$@"; }
120# @FUNCTION: tc-getBUILD_CC
121# @USAGE: [toolchain prefix]
122# @RETURN: name of the C compiler for building binaries to run on the build machine
123tc-getBUILD_CC() { tc-getBUILD_PROG CC gcc "$@"; }
124# @FUNCTION: tc-getBUILD_CPP
125# @USAGE: [toolchain prefix]
126# @RETURN: name of the C preprocessor for building binaries to run on the build machine
127tc-getBUILD_CPP() { tc-getBUILD_PROG CPP cpp "$@"; }
128# @FUNCTION: tc-getBUILD_CXX
129# @USAGE: [toolchain prefix]
130# @RETURN: name of the C++ compiler for building binaries to run on the build machine
131tc-getBUILD_CXX() { tc-getBUILD_PROG CXX g++ "$@"; }
132# @FUNCTION: tc-getBUILD_LD
133# @USAGE: [toolchain prefix]
134# @RETURN: name of the linker for building binaries to run on the build machine
135tc-getBUILD_LD() { tc-getBUILD_PROG LD ld "$@"; }
136# @FUNCTION: tc-getBUILD_STRIP
137# @USAGE: [toolchain prefix]
138# @RETURN: name of the strip program for building binaries to run on the build machine
139tc-getBUILD_STRIP() { tc-getBUILD_PROG STRIP strip "$@"; }
140# @FUNCTION: tc-getBUILD_NM
141# @USAGE: [toolchain prefix]
142# @RETURN: name of the symbol/object thingy for building binaries to run on the build machine
143tc-getBUILD_NM() { tc-getBUILD_PROG NM nm "$@"; }
144# @FUNCTION: tc-getBUILD_RANLIB
145# @USAGE: [toolchain prefix]
146# @RETURN: name of the archiver indexer for building binaries to run on the build machine
147tc-getBUILD_RANLIB() { tc-getBUILD_PROG RANLIB ranlib "$@"; }
148# @FUNCTION: tc-getBUILD_OBJCOPY
149# @USAGE: [toolchain prefix]
150# @RETURN: name of the object copier for building binaries to run on the build machine
151tc-getBUILD_OBJCOPY() { tc-getBUILD_PROG OBJCOPY objcopy "$@"; }
152# @FUNCTION: tc-getBUILD_PKG_CONFIG
153# @USAGE: [toolchain prefix]
154# @RETURN: name of the pkg-config tool for building binaries to run on the build machine
155tc-getBUILD_PKG_CONFIG() { tc-getBUILD_PROG PKG_CONFIG pkg-config "$@"; }
115 156
116# @FUNCTION: tc-export 157# @FUNCTION: tc-export
117# @USAGE: <list of toolchain variables> 158# @USAGE: <list of toolchain variables>
118# @DESCRIPTION: 159# @DESCRIPTION:
119# Quick way to export a bunch of compiler vars at once. 160# Quick way to export a bunch of compiler vars at once.
134# @FUNCTION: tc-is-softfloat 175# @FUNCTION: tc-is-softfloat
135# @DESCRIPTION: 176# @DESCRIPTION:
136# See if this toolchain is a softfloat based one. 177# See if this toolchain is a softfloat based one.
137# @CODE 178# @CODE
138# The possible return values: 179# The possible return values:
139# - only: the target is always softfloat (never had fpu) 180# - only: the target is always softfloat (never had fpu)
140# - yes: the target should support softfloat 181# - yes: the target should support softfloat
182# - softfp: (arm specific) the target should use hardfloat insns, but softfloat calling convention
141# - no: the target should support hardfloat 183# - no: the target doesn't support softfloat
142# @CODE 184# @CODE
143# This allows us to react differently where packages accept 185# This allows us to react differently where packages accept
144# softfloat flags in the case where support is optional, but 186# softfloat flags in the case where support is optional, but
145# rejects softfloat flags where the target always lacks an fpu. 187# rejects softfloat flags where the target always lacks an fpu.
146tc-is-softfloat() { 188tc-is-softfloat() {
189 local CTARGET=${CTARGET:-${CHOST}}
147 case ${CTARGET} in 190 case ${CTARGET} in
148 bfin*|h8300*) 191 bfin*|h8300*)
149 echo "only" ;; 192 echo "only" ;;
150 *) 193 *)
151 [[ ${CTARGET//_/-} == *-softfloat-* ]] \ 194 if [[ ${CTARGET//_/-} == *-softfloat-* ]] ; then
152 && echo "yes" \ 195 echo "yes"
196 elif [[ ${CTARGET//_/-} == *-softfp-* ]] ; then
197 echo "softfp"
198 else
153 || echo "no" 199 echo "no"
200 fi
154 ;; 201 ;;
155 esac 202 esac
156} 203}
204
205# @FUNCTION: tc-is-static-only
206# @DESCRIPTION:
207# Return shell true if the target does not support shared libs, shell false
208# otherwise.
209tc-is-static-only() {
210 local host=${CTARGET:-${CHOST}}
211
212 # *MiNT doesn't have shared libraries, only platform so far
213 return $([[ ${host} == *-mint* ]])
214}
215
216# @FUNCTION: tc-export_build_env
217# @USAGE: [compiler variables]
218# @DESCRIPTION:
219# Export common build related compiler settings.
220tc-export_build_env() {
221 tc-export "$@"
222 : ${BUILD_CFLAGS:=-O1 -pipe}
223 : ${BUILD_CXXFLAGS:=-O1 -pipe}
224 : ${BUILD_CPPFLAGS:=}
225 : ${BUILD_LDFLAGS:=}
226 export BUILD_{C,CXX,CPP,LD}FLAGS
227}
228
229# @FUNCTION: tc-env_build
230# @USAGE: <command> [command args]
231# @INTERNAL
232# @DESCRIPTION:
233# Setup the compile environment to the build tools and then execute the
234# specified command. We use tc-getBUILD_XX here so that we work with
235# all of the semi-[non-]standard env vars like $BUILD_CC which often
236# the target build system does not check.
237tc-env_build() {
238 tc-export_build_env
239 CFLAGS=${BUILD_CFLAGS} \
240 CXXFLAGS=${BUILD_CXXFLAGS} \
241 CPPFLAGS=${BUILD_CPPFLAGS} \
242 LDFLAGS=${BUILD_LDFLAGS} \
243 AR=$(tc-getBUILD_AR) \
244 AS=$(tc-getBUILD_AS) \
245 CC=$(tc-getBUILD_CC) \
246 CPP=$(tc-getBUILD_CPP) \
247 CXX=$(tc-getBUILD_CXX) \
248 LD=$(tc-getBUILD_LD) \
249 NM=$(tc-getBUILD_NM) \
250 PKG_CONFIG=$(tc-getBUILD_PKG_CONFIG) \
251 RANLIB=$(tc-getBUILD_RANLIB) \
252 "$@"
253}
254
255# @FUNCTION: econf_build
256# @USAGE: [econf flags]
257# @DESCRIPTION:
258# Sometimes we need to locally build up some tools to run on CBUILD because
259# the package has helper utils which are compiled+executed when compiling.
260# This won't work when cross-compiling as the CHOST is set to a target which
261# we cannot natively execute.
262#
263# For example, the python package will build up a local python binary using
264# a portable build system (configure+make), but then use that binary to run
265# local python scripts to build up other components of the overall python.
266# We cannot rely on the python binary in $PATH as that often times will be
267# a different version, or not even installed in the first place. Instead,
268# we compile the code in a different directory to run on CBUILD, and then
269# use that binary when compiling the main package to run on CHOST.
270#
271# For example, with newer EAPIs, you'd do something like:
272# @CODE
273# src_configure() {
274# ECONF_SOURCE=${S}
275# if tc-is-cross-compiler ; then
276# mkdir "${WORKDIR}"/${CBUILD}
277# pushd "${WORKDIR}"/${CBUILD} >/dev/null
278# econf_build --disable-some-unused-stuff
279# popd >/dev/null
280# fi
281# ... normal build paths ...
282# }
283# src_compile() {
284# if tc-is-cross-compiler ; then
285# pushd "${WORKDIR}"/${CBUILD} >/dev/null
286# emake one-or-two-build-tools
287# ln/mv build-tools to normal build paths in ${S}/
288# popd >/dev/null
289# fi
290# ... normal build paths ...
291# }
292# @CODE
293econf_build() {
294 tc-env_build econf --build=${CBUILD:-${CHOST}} "$@"
295}
296
297# @FUNCTION: tc-has-openmp
298# @USAGE: [toolchain prefix]
299# @DESCRIPTION:
300# See if the toolchain supports OpenMP.
301tc-has-openmp() {
302 local base="${T}/test-tc-openmp"
303 cat <<-EOF > "${base}.c"
304 #include <omp.h>
305 int main() {
306 int nthreads, tid, ret = 0;
307 #pragma omp parallel private(nthreads, tid)
308 {
309 tid = omp_get_thread_num();
310 nthreads = omp_get_num_threads(); ret += tid + nthreads;
311 }
312 return ret;
313 }
314 EOF
315 $(tc-getCC "$@") -fopenmp "${base}.c" -o "${base}" >&/dev/null
316 local ret=$?
317 rm -f "${base}"*
318 return ${ret}
319}
320
321# @FUNCTION: tc-has-tls
322# @USAGE: [-s|-c|-l] [toolchain prefix]
323# @DESCRIPTION:
324# See if the toolchain supports thread local storage (TLS). Use -s to test the
325# compiler, -c to also test the assembler, and -l to also test the C library
326# (the default).
327tc-has-tls() {
328 local base="${T}/test-tc-tls"
329 cat <<-EOF > "${base}.c"
330 int foo(int *i) {
331 static __thread int j = 0;
332 return *i ? j : *i;
333 }
334 EOF
335 local flags
336 case $1 in
337 -s) flags="-S";;
338 -c) flags="-c";;
339 -l) ;;
340 -*) die "Usage: tc-has-tls [-c|-l] [toolchain prefix]";;
341 esac
342 : ${flags:=-fPIC -shared -Wl,-z,defs}
343 [[ $1 == -* ]] && shift
344 $(tc-getCC "$@") ${flags} "${base}.c" -o "${base}" >&/dev/null
345 local ret=$?
346 rm -f "${base}"*
347 return ${ret}
348}
349
157 350
158# Parse information from CBUILD/CHOST/CTARGET rather than 351# Parse information from CBUILD/CHOST/CTARGET rather than
159# use external variables from the profile. 352# use external variables from the profile.
160tc-ninja_magic_to_arch() { 353tc-ninja_magic_to_arch() {
161ninj() { [[ ${type} == "kern" ]] && echo $1 || echo $2 ; } 354ninj() { [[ ${type} == "kern" ]] && echo $1 || echo $2 ; }
162 355
163 local type=$1 356 local type=$1
164 local host=$2 357 local host=$2
165 [[ -z ${host} ]] && host=${CTARGET:-${CHOST}} 358 [[ -z ${host} ]] && host=${CTARGET:-${CHOST}}
166 359
360 local KV=${KV:-${KV_FULL}}
361 [[ -z ${KV} ]] && die "toolchain-funcs.eclass: Kernel version could not be determined, please inherit kernel-2 or linux-info"
362
167 case ${host} in 363 case ${host} in
168 powerpc-apple-darwin*) 364 aarch64*) ninj aarch64 arm;;
169 echo ppc-macos;;
170 powerpc64-apple-darwin*)
171 echo ppc64-macos;;
172 i?86-apple-darwin*)
173 echo x86-macos;;
174 x86_64-apple-darwin*)
175 echo x64-macos;;
176 sparc-sun-solaris*)
177 echo sparc-solaris;;
178 sparcv9-sun-solaris*)
179 echo sparc64-solaris;;
180 i?86-pc-solaris*)
181 echo x86-solaris;;
182 x86_64-pc-solaris*)
183 echo x64-solaris;;
184 powerpc-ibm-aix*)
185 echo ppc-aix;;
186 mips-sgi-irix*)
187 echo mips-irix;;
188 ia64-hp-hpux*)
189 echo ia64-hpux;;
190 i?86-pc-freebsd*)
191 echo x86-freebsd;;
192 x86_64-pc-freebsd*)
193 echo x64-freebsd;;
194 i?86-pc-netbsd*)
195 echo x86-netbsd;;
196 i?86-pc-interix*)
197 echo x86-interix;;
198 i?86-pc-winnt*)
199 echo x86-winnt;;
200 i*-pc-freebsd*)
201 echo x86-freebsd;;
202 x86_64-pc-freebsd*)
203 echo x64-freebsd;;
204
205 alpha*) echo alpha;; 365 alpha*) echo alpha;;
206 arm*) echo arm;; 366 arm*) echo arm;;
207 avr*) ninj avr32 avr;; 367 avr*) ninj avr32 avr;;
208 bfin*) ninj blackfin bfin;; 368 bfin*) ninj blackfin bfin;;
209 cris*) echo cris;; 369 cris*) echo cris;;
222 m68*) echo m68k;; 382 m68*) echo m68k;;
223 mips*) echo mips;; 383 mips*) echo mips;;
224 nios2*) echo nios2;; 384 nios2*) echo nios2;;
225 nios*) echo nios;; 385 nios*) echo nios;;
226 powerpc*) 386 powerpc*)
227 # Starting with linux-2.6.15, the 'ppc' and 'ppc64' trees 387 # Starting with linux-2.6.15, the 'ppc' and 'ppc64' trees
228 # have been unified into simply 'powerpc', but until 2.6.16, 388 # have been unified into simply 'powerpc', but until 2.6.16,
229 # ppc32 is still using ARCH="ppc" as default 389 # ppc32 is still using ARCH="ppc" as default
230 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]] && [[ ${type} == "kern" ]] ; then 390 if [[ ${type} == "kern" ]] && [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]] ; then
231 echo powerpc 391 echo powerpc
232 elif [[ $(KV_to_int ${KV}) -eq $(KV_to_int 2.6.15) ]] && [[ ${type} == "kern" ]] ; then 392 elif [[ ${type} == "kern" ]] && [[ $(KV_to_int ${KV}) -eq $(KV_to_int 2.6.15) ]] ; then
233 if [[ ${host} == powerpc64* ]] || [[ ${PROFILE_ARCH} == "ppc64" ]] ; then 393 if [[ ${host} == powerpc64* ]] || [[ ${PROFILE_ARCH} == "ppc64" ]] ; then
234 echo powerpc 394 echo powerpc
235 else 395 else
236 echo ppc 396 echo ppc
237 fi 397 fi
238 elif [[ ${host} == powerpc64* ]] ; then 398 elif [[ ${host} == powerpc64* ]] ; then
239 echo ppc64 399 echo ppc64
240 elif [[ ${PROFILE_ARCH} == "ppc64" ]] ; then 400 elif [[ ${PROFILE_ARCH} == "ppc64" ]] ; then
241 ninj ppc64 ppc 401 ninj ppc64 ppc
242 else 402 else
243 echo ppc 403 echo ppc
244 fi 404 fi
245 ;; 405 ;;
246 s390*) echo s390;; 406 s390*) echo s390;;
247 sh64*) ninj sh64 sh;; 407 sh64*) ninj sh64 sh;;
248 sh*) echo sh;; 408 sh*) echo sh;;
249 sparc64*) ninj sparc64 sparc;; 409 sparc64*) ninj sparc64 sparc;;
250 sparc*) [[ ${PROFILE_ARCH} == "sparc64" ]] \ 410 sparc*) [[ ${PROFILE_ARCH} == "sparc64" ]] \
251 && ninj sparc64 sparc \ 411 && ninj sparc64 sparc \
252 || echo sparc 412 || echo sparc
253 ;; 413 ;;
254 vax*) echo vax;; 414 vax*) echo vax;;
415 x86_64*freebsd*) echo amd64;;
255 x86_64*) 416 x86_64*)
256 # Starting with linux-2.6.24, the 'x86_64' and 'i386' 417 # Starting with linux-2.6.24, the 'x86_64' and 'i386'
257 # trees have been unified into 'x86'. 418 # trees have been unified into 'x86'.
258 if [[ ${type} == "kern" ]] && [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.24) ]] ; then 419 if [[ ${type} == "kern" ]] && [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.24) ]] ; then
259 echo x86 420 echo x86
285 local host=$1 446 local host=$1
286 [[ -z ${host} ]] && host=${CTARGET:-${CHOST}} 447 [[ -z ${host} ]] && host=${CTARGET:-${CHOST}}
287 host=${host%%-*} 448 host=${host%%-*}
288 449
289 case ${host} in 450 case ${host} in
451 aarch64*be) echo big;;
452 aarch64) echo little;;
290 alpha*) echo big;; 453 alpha*) echo big;;
291 arm*b*) echo big;; 454 arm*b*) echo big;;
292 arm*) echo little;; 455 arm*) echo little;;
293 cris*) echo little;; 456 cris*) echo little;;
294 hppa*) echo big;; 457 hppa*) echo big;;
305 x86_64*) echo little;; 468 x86_64*) echo little;;
306 *) echo wtf;; 469 *) echo wtf;;
307 esac 470 esac
308} 471}
309 472
473# Internal func. The first argument is the version info to expand.
474# Query the preprocessor to improve compatibility across different
475# compilers rather than maintaining a --version flag matrix. #335943
476_gcc_fullversion() {
477 local ver="$1"; shift
478 set -- `$(tc-getCPP "$@") -E -P - <<<"__GNUC__ __GNUC_MINOR__ __GNUC_PATCHLEVEL__"`
479 eval echo "$ver"
480}
481
310# @FUNCTION: gcc-fullversion 482# @FUNCTION: gcc-fullversion
311# @RETURN: compiler version (major.minor.micro: [3.4.6]) 483# @RETURN: compiler version (major.minor.micro: [3.4.6])
312gcc-fullversion() { 484gcc-fullversion() {
313 $(tc-getCC "$@") -dumpversion 485 _gcc_fullversion '$1.$2.$3' "$@"
314} 486}
315# @FUNCTION: gcc-version 487# @FUNCTION: gcc-version
316# @RETURN: compiler version (major.minor: [3.4].6) 488# @RETURN: compiler version (major.minor: [3.4].6)
317gcc-version() { 489gcc-version() {
318 gcc-fullversion "$@" | cut -f1,2 -d. 490 _gcc_fullversion '$1.$2' "$@"
319} 491}
320# @FUNCTION: gcc-major-version 492# @FUNCTION: gcc-major-version
321# @RETURN: major compiler version (major: [3].4.6) 493# @RETURN: major compiler version (major: [3].4.6)
322gcc-major-version() { 494gcc-major-version() {
323 gcc-version "$@" | cut -f1 -d. 495 _gcc_fullversion '$1' "$@"
324} 496}
325# @FUNCTION: gcc-minor-version 497# @FUNCTION: gcc-minor-version
326# @RETURN: minor compiler version (minor: 3.[4].6) 498# @RETURN: minor compiler version (minor: 3.[4].6)
327gcc-minor-version() { 499gcc-minor-version() {
328 gcc-version "$@" | cut -f2 -d. 500 _gcc_fullversion '$2' "$@"
329} 501}
330# @FUNCTION: gcc-micro-version 502# @FUNCTION: gcc-micro-version
331# @RETURN: micro compiler version (micro: 3.4.[6]) 503# @RETURN: micro compiler version (micro: 3.4.[6])
332gcc-micro-version() { 504gcc-micro-version() {
333 gcc-fullversion "$@" | cut -f3 -d. | cut -f1 -d- 505 _gcc_fullversion '$3' "$@"
334} 506}
335 507
336# Returns the installation directory - internal toolchain 508# Returns the installation directory - internal toolchain
337# function for use by _gcc-specs-exists (for flag-o-matic). 509# function for use by _gcc-specs-exists (for flag-o-matic).
338_gcc-install-dir() { 510_gcc-install-dir() {
438# Note that you should in general use the unversioned name of 610# Note that you should in general use the unversioned name of
439# the library (libfoo.so), as ldconfig should usually update it 611# the library (libfoo.so), as ldconfig should usually update it
440# correctly to point to the latest version of the library present. 612# correctly to point to the latest version of the library present.
441gen_usr_ldscript() { 613gen_usr_ldscript() {
442 local lib libdir=$(get_libdir) output_format="" auto=false suffix=$(get_libname) 614 local lib libdir=$(get_libdir) output_format="" auto=false suffix=$(get_libname)
615 [[ -z ${ED+set} ]] && local ED=${D%/}${EPREFIX}/
616
617 tc-is-static-only && return
618
619 # Eventually we'd like to get rid of this func completely #417451
620 case ${CTARGET:-${CHOST}} in
621 *-darwin*) ;;
622 *linux*|*-freebsd*|*-openbsd*|*-netbsd*)
623 use prefix && return 0 ;;
624 *) return 0 ;;
625 esac
626
443 # Just make sure it exists 627 # Just make sure it exists
444 dodir /usr/${libdir} 628 dodir /usr/${libdir}
445 629
446 if [[ $1 == "-a" ]] ; then 630 if [[ $1 == "-a" ]] ; then
447 auto=true 631 auto=true
453 # is referenced ... makes multilib saner 637 # is referenced ... makes multilib saner
454 output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p') 638 output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
455 [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )" 639 [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
456 640
457 for lib in "$@" ; do 641 for lib in "$@" ; do
458 642 local tlib
643 if ${auto} ; then
644 lib="lib${lib}${suffix}"
645 else
459 # Ensure /lib/${lib} exists to avoid dangling scripts/symlinks. 646 # Ensure /lib/${lib} exists to avoid dangling scripts/symlinks.
460 # This especially is for AIX where $(get_libname) can return ".a", 647 # This especially is for AIX where $(get_libname) can return ".a",
461 # so /lib/${lib} might be moved to /usr/lib/${lib} (by accident). 648 # so /lib/${lib} might be moved to /usr/lib/${lib} (by accident).
462 [[ -r "${ED}"/${libdir}/${lib} ]] || continue 649 [[ -r ${ED}/${libdir}/${lib} ]] || continue
650 #TODO: better die here?
651 fi
463 652
464 case ${CHOST} in 653 case ${CTARGET:-${CHOST}} in
465 *-darwin*) 654 *-darwin*)
655 if ${auto} ; then
656 tlib=$(scanmacho -qF'%S#F' "${ED}"/usr/${libdir}/${lib})
657 else
658 tlib=$(scanmacho -qF'%S#F' "${ED}"/${libdir}/${lib})
659 fi
660 [[ -z ${tlib} ]] && die "unable to read install_name from ${lib}"
661 tlib=${tlib##*/}
662
663 if ${auto} ; then
664 mv "${ED}"/usr/${libdir}/${lib%${suffix}}.*${suffix#.} "${ED}"/${libdir}/ || die
665 # some install_names are funky: they encode a version
666 if [[ ${tlib} != ${lib%${suffix}}.*${suffix#.} ]] ; then
667 mv "${ED}"/usr/${libdir}/${tlib%${suffix}}.*${suffix#.} "${ED}"/${libdir}/ || die
668 fi
669 rm -f "${ED}"/${libdir}/${lib}
670 fi
671
466 # Mach-O files have an id, which is like a soname, it tells how 672 # Mach-O files have an id, which is like a soname, it tells how
467 # another object linking against this lib should reference it. 673 # another object linking against this lib should reference it.
468 # Since we moved the lib from usr/lib into lib this reference is 674 # Since we moved the lib from usr/lib into lib this reference is
469 # wrong. Hence, we update it here. We don't configure with 675 # wrong. Hence, we update it here. We don't configure with
470 # libdir=/lib because that messes up libtool files. 676 # libdir=/lib because that messes up libtool files.
471 # Make sure we don't lose the specific version, so just modify the 677 # Make sure we don't lose the specific version, so just modify the
472 # existing install_name 678 # existing install_name
473 install_name=$(otool -DX "${ED}"/${libdir}/${lib}) 679 if [[ ! -w "${ED}/${libdir}/${tlib}" ]] ; then
474 [[ -z ${install_name} ]] && die "No install name found for ${ED}/${libdir}/${lib}" 680 chmod u+w "${ED}${libdir}/${tlib}" # needed to write to it
681 local nowrite=yes
682 fi
475 install_name_tool \ 683 install_name_tool \
476 -id "${EPREFIX}"/${libdir}/${install_name##*/} \ 684 -id "${EPREFIX}"/${libdir}/${tlib} \
477 "${ED}"/${libdir}/${lib} 685 "${ED}"/${libdir}/${tlib} || die "install_name_tool failed"
686 [[ -n ${nowrite} ]] && chmod u-w "${ED}${libdir}/${tlib}"
478 # Now as we don't use GNU binutils and our linker doesn't 687 # Now as we don't use GNU binutils and our linker doesn't
479 # understand linker scripts, just create a symlink. 688 # understand linker scripts, just create a symlink.
480 pushd "${ED}/usr/${libdir}" > /dev/null 689 pushd "${ED}/usr/${libdir}" > /dev/null
481 ln -snf "../../${libdir}/${lib}" "${lib}" 690 ln -snf "../../${libdir}/${tlib}" "${lib}"
482 popd > /dev/null 691 popd > /dev/null
483 ;; 692 ;;
484 *-aix*|*-irix*|*-hpux*)
485 # we don't have GNU binutils on these platforms, so we symlink
486 # instead, which seems to work fine. Keep it relative, otherwise
487 # we break some QA checks in Portage
488 pushd "${ED}/usr/${libdir}" > /dev/null
489 ln -snf "../../${libdir}/${lib}" "${lib}"
490 popd > /dev/null
491 ;;
492 *-interix*|*-winnt*)
493 # on interix, the linker scripts would work fine in _most_
494 # situations. if a library links to such a linker script the
495 # absolute path to the correct library is inserted into the binary,
496 # which is wrong, since anybody linking _without_ libtool will miss
497 # some dependencies, since the stupid linker cannot find libraries
498 # hardcoded with absolute paths (as opposed to the loader, which
499 # seems to be able to do this).
500 # this has been seen while building shared-mime-info which needs
501 # libxml2, but links without libtool (and does not add libz to the
502 # command line by itself).
503 pushd "${ED}/usr/${libdir}" > /dev/null
504 ln -snf "../../${libdir}/${lib}" "${lib}"
505 popd > /dev/null
506 ;;
507 *-mint*)
508 # do nothing
509 return
510 ;;
511 *) 693 *)
512 local tlib
513 if ${auto} ; then 694 if ${auto} ; then
514 lib="lib${lib}${suffix}"
515 tlib=$(scanelf -qF'%S#F' "${D}"/usr/${libdir}/${lib}) 695 tlib=$(scanelf -qF'%S#F' "${ED}"/usr/${libdir}/${lib})
696 [[ -z ${tlib} ]] && die "unable to read SONAME from ${lib}"
516 mv "${D}"/usr/${libdir}/${lib}* "${D}"/${libdir}/ || die 697 mv "${ED}"/usr/${libdir}/${lib}* "${ED}"/${libdir}/ || die
517 # some SONAMEs are funky: they encode a version before the .so 698 # some SONAMEs are funky: they encode a version before the .so
518 if [[ ${tlib} != ${lib}* ]] ; then 699 if [[ ${tlib} != ${lib}* ]] ; then
519 mv "${D}"/usr/${libdir}/${tlib}* "${D}"/${libdir}/ || die 700 mv "${ED}"/usr/${libdir}/${tlib}* "${ED}"/${libdir}/ || die
520 fi 701 fi
521 [[ -z ${tlib} ]] && die "unable to read SONAME from ${lib}"
522 rm -f "${D}"/${libdir}/${lib} 702 rm -f "${ED}"/${libdir}/${lib}
523 else 703 else
524 tlib=${lib} 704 tlib=${lib}
525 fi 705 fi
526 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 706 cat > "${ED}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
527 /* GNU ld script 707 /* GNU ld script
528 Since Gentoo has critical dynamic libraries in /lib, and the static versions 708 Since Gentoo has critical dynamic libraries in /lib, and the static versions
529 in /usr/lib, we need to have a "fake" dynamic lib in /usr/lib, otherwise we 709 in /usr/lib, we need to have a "fake" dynamic lib in /usr/lib, otherwise we
530 run into linking problems. This "fake" dynamic lib is a linker script that 710 run into linking problems. This "fake" dynamic lib is a linker script that
531 redirects the linker to the real lib. And yes, this works in the cross- 711 redirects the linker to the real lib. And yes, this works in the cross-
532 compiling scenario as the sysroot-ed linker will prepend the real path. 712 compiling scenario as the sysroot-ed linker will prepend the real path.
533 713
534 See bug http://bugs.gentoo.org/4411 for more info. 714 See bug http://bugs.gentoo.org/4411 for more info.
535 */ 715 */
536 ${output_format} 716 ${output_format}
537 GROUP ( /${libdir}/${tlib} ) 717 GROUP ( ${EPREFIX}/${libdir}/${tlib} )
538 END_LDSCRIPT 718 END_LDSCRIPT
539 ;; 719 ;;
540 esac 720 esac
541 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 721 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
542 done 722 done
543} 723}
544 724
545# This function is for AIX only.
546#
547# Showing a sample IMO is the best description:
548#
549# First, AIX has its own /usr/lib/libiconv.a containing 'shr.o' and 'shr4.o'.
550# Both of them are shared-objects packed into an archive, thus /usr/lib/libiconv.a
551# is a shared library (!), even it is called lib*.a.
552# This is the default layout on aix for shared libraries.
553# Read the ld(1) manpage for more information.
554#
555# But now, we want to install GNU libiconv (sys-libs/libiconv) both as
556# shared and static library.
557# AIX (since 4.3) can create shared libraries if '-brtl' or '-G' linker flags
558# are used.
559#
560# Now assume we have GNU tar installed while GNU libiconv was not.
561# This tar now has a runtime dependency on "libiconv.a(shr4.o)".
562# With our ld-wrapper (from sys-devel/binutils-config) we add EPREFIX/usr/lib
563# as linker path, thus it is recorded as loader path into the binary.
564#
565# When having libiconv.a (the static GNU libiconv) in prefix, the loader finds
566# that one and claims that it does not contain an 'shr4.o' object file:
567#
568# Could not load program tar:
569# Dependent module EPREFIX/usr/lib/libiconv.a(shr4.o) could not be loaded.
570# Member shr4.o is not found in archive
571#
572# According to gcc's "host/target specific installation notes" for *-ibm-aix* [1],
573# we can extract that 'shr4.o' from /usr/lib/libiconv.a, mark it as
574# non-linkable, and include it in our new static library.
575#
576# [1] http://gcc.gnu.org/install/specific.html#x-ibm-aix
577#
578# usage:
579# keep_aix_runtime_object <target-archive inside EPREFIX> <source-archive(objects)>
580# keep_aix_runtime_object "/usr/lib/libiconv.a "/usr/lib/libiconv.a(shr4.o,...)"
581keep_aix_runtime_objects() {
582 [[ ${CHOST} == *-*-aix* ]] || return 0
583
584 local target=$1
585 shift
586 local sources="$@"
587
588 # strip possible ${ED} prefixes
589 target=${target##/}
590 target=${target#${D##/}}
591 target=${target#${EPREFIX##/}}
592 target=${target##/}
593
594 if ! $(tc-getAR) -t "${ED}${target}" &>/dev/null; then
595 if [[ -e ${ED}${target} ]]; then
596 ewarn "${target} is not an archive."
597 fi
598 return 0
599 fi 725fi
600
601 local tmpdir=${TMP}/keep_aix_runtime_object-$$
602 mkdir ${tmpdir} || die
603
604 local origdir=$(pwd)
605 local s
606 for s in ${sources}; do
607 local sourcelib sourceobjs so
608 # format of $s: "/usr/lib/libiconv.a(shr4.o,shr.o)"
609 sourcelib=${s%%(*}
610 sourceobjs=${s#*(}
611 sourceobjs=${sourceobjs%)}
612 sourceobjs=${sourceobjs//,/ }
613 cd ${tmpdir} || die
614 for so in ${sourceobjs}; do
615 ebegin "keeping aix runtime object '${sourcelib}(${so})' in '${EPREFIX}/${target}'"
616 if ! $(tc-getAR) -x "${sourcelib}" ${so}; then
617 eend 1
618 continue
619 fi
620 chmod +w ${so} &&
621 $(tc-getSTRIP) -e ${so} &&
622 $(tc-getAR) -q "${ED}${target}" ${so} &&
623 eend 0 ||
624 eend 1
625 done
626 done
627 cd "${origdir}"
628}

Legend:
Removed from v.1.89  
changed lines
  Added in v.1.118

  ViewVC Help
Powered by ViewVC 1.1.20